<?php

/*

----- DE / german ----------

Backlink-Check

Der "Backlink-Checker" der
opensource company
steht unter einer
Creative Commons Namensnennung-Keine Bearbeitung 3.0 Deutschland Lizenz.

http://creativecommons.org/licenses/by-nd/3.0/de/

Idee, lose Fen und Design-Feinschliff:		Alexander Hu, opensource company
http://www.opensource-company.de

Das ganze Gefrickel, preg_match und Design:	Felix Kraneburg, novuspix
http://www.novuspix.de

Verbesserung des Regex in der Version 1.2:	Berthold Lausch, novamaster
http://www.nova-master.de

Dieser Kommentar mu in allen Dateien erhalten bleiben,
ansonsten ist dies als Lizenzversto zu werten

----- EN / english -----

Backlink-Check

The "Backlink-Checker" from
opensource company
is published under
Attribution-No Derivative Works 3.0 Germany licence.

http://creativecommons.org/licenses/by-nd/3.0/de/deed.en

idea, snippets und design-finish:	Alexander Hu, opensource company
http://www.opensource-company.de

the whole fuzzy stuff, preg_match and design:	Felix Kraneburg, novuspix
http://www.novuspix.de

Regex optimisation for version 1.2:	Berthold Lausch, novamaster
http://www.nova-master.de

This comment must stay intact in all files,
otherwise it will be a licence-break.

*/

function checkBacklink($target_url, $backlink_url, $link_text)
{
	// Fllt Result-Array mit Standardwerten
	$result['url']		= 0;
	$result['nofollow']	= 0;
	$result['target']	= '';
	$result['linktext']	= 0;
	$result['robots-txt']	= 0;

	// Prft ob robots.txt existiert und liest diese aus
	preg_match_all('/http\:\/\/www\.[a-zA-Z0-9-]+\.([a-z]{2,4})/', $target_url, $base_url);
	$base_url = $base_url[0][0];

	$fp = @fopen($base_url."/robots.txt", 'r');
	$result['robots'] = ($fp) ? 0: 2;
	if($result['robots'] == 0) {
		while(!feof($fp)){
			$line = fgets($fp);
			$result['robots'] = (preg_match("/Disallow/", $line) OR preg_match("/disallow/", $line) AND preg_match("#$target_url#", $line)) ? 1: 0;
		}
	}
	@fclose($fp);

	// Prft ob Meta-Tag Robots auf nofollow gesetzt ist
	$meta = get_meta_tags($target_url);
	$result['robots-meta'] = $meta['robots'];

	$contents = file_get_contents($target_url, 'r');
	// Sammelt alle Links auf der Seite

//	preg_match_all('|<a\s+href\s*=\s*[\"\'](.*)[\'\"]\s*>.*</a>|Ui', $contents, $links);
	preg_match_all('|<a\s[^>]*href=[\"\']([^\"\']*?)[\"\'][^>]*>[^<]*</a>|Uism', $contents, $links,PREG_PATTERN_ORDER );
	// Prft alle Links
	foreach($links[0] as $link)
	{
		$check_url = preg_match("#$backlink_url#", $link);

	if($check_url)
		{
			$result['url']      = 1;
			$result['nofollow'] = (preg_match("/nofollow/", $link)) 	 ? 1: $result['nofollow'];
			$result['target'] 	= (preg_match("/_blank/", $link)) 		 ? '_blank': '_self';
			$result['linktext'] = (preg_match("/$link_text/", $link)) 	 ? 1: $link_text;
		}
	}
	return $result;
}

?>